package com.zerohighdef.geoffrey.Commands;

import com.google.gson.JsonElement;
import com.zerohighdef.geoffrey.GeoffreyMC;
import com.zerohighdef.geoffrey.Objects.GeoffreyAPICallback;
import com.zerohighdef.geoffrey.Objects.GeoffreyCommand;
import com.zerohighdef.geoffrey.Objects.GeoffreyCommandError;
import org.apache.commons.lang.StringUtils;
import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;

import java.util.HashMap;
import java.util.Map;

public class FindFarmCommand extends GeoffreyCommand {
    public FindFarmCommand(GeoffreyMC plugin) {
        super(plugin);
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {

        if (args.length > 0) {
            String resourceName = StringUtils.join(args, " ");
            Map<String, String> params = new HashMap<String, String>();

            params.put("resource_name", resourceName);
            RunCommand("find_farm", params, Method.GET, new CommandCallback(sender, resourceName));
        }
        else {
            sender.sendMessage(ChatColor.RED + "You must specify a resource name.");
            return false;
        }

        return true;
    }


    private class CommandCallback extends GeoffreyAPICallback {
        private String resourceName;

        CommandCallback(CommandSender sender, String resourceName) {
            super(sender);
            this.resourceName = resourceName;
            errors.put("ResourceNotFoundError", "No farms found that produce " + this.resourceName + ".");
        }

        @Override
        public void invoke(String s) {
            try {
                JsonElement json = parseJSON(s);
                String msg =  ChatColor.BOLD + "The following farms produce " + resourceName + ":\n" + ChatColor.RESET + locationList(json, 5);
                commandSender.sendMessage(ChatColor.GREEN + msg);
            }
            catch (GeoffreyCommandError e) {
                return;
            }
        }
    }
}
