package com.zerohighdef.geoffrey.Objects;

import com.zerohighdef.geoffrey.GeoffreyMC;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import xyz.etztech.core.web.CoreWeb;
import xyz.etztech.core.web.ICallback;

import java.util.Map;

public class GeoffreyCommand implements CommandExecutor {
    protected GeoffreyMC plugin;

    protected enum Method {
        GET, POST
    }

    public GeoffreyCommand(GeoffreyMC plugin) {
        this.plugin = plugin;
    }

    protected void RunCommand(String commandName, Map<String, String> params, Method requestType, ICallback callback) {
        String url = plugin.getBaseAPIURL() + "/command/" + commandName + "/";
        params.put("api", plugin.getAPIToken());

        if (requestType == Method.GET) {
            CoreWeb.asyncGetCallback(plugin, url, params, callback);
        }
        else {
            CoreWeb.asyncPostCallback(plugin, url, params, callback);
        }

    }


    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        return false;
    }
}
