package com.zerohighdef.geoffrey.Objects;

import org.bukkit.World;

import java.text.ParseException;
import java.util.LinkedList;
import java.util.List;

public class GeoffreyUtil {
    public static List<String> parseArgs(String [] args) throws ParseException {
        LinkedList<String> parsedArgs = new LinkedList<>();
        boolean parsingMultiWordArg = false;
        StringBuilder parsedArg = new StringBuilder();

        for (String arg: args) {
            boolean foundEndOfString = false;

            if (!parsingMultiWordArg) {
                parsedArg = new StringBuilder();
            }

            for (char c: arg.toCharArray()) {
                if (c == '"') {
                    if (parsingMultiWordArg) {
                        foundEndOfString = true;
                        parsingMultiWordArg = false;
                    }
                    else {
                        parsingMultiWordArg = true;
                    }
                }
            }

            parsedArg.append(arg);

            if (parsingMultiWordArg) {
                parsedArg.append(" ");
            }

            if (foundEndOfString || !parsingMultiWordArg) {
                parsedArgs.add(parsedArg.toString().replace("\"", ""));
            }
        }

        if (parsingMultiWordArg) {
            throw new ParseException("No matching \" found", 0);
        }

        return parsedArgs;
    }

    public static String getGeoffreyDimensionString(World.Environment environment) {
        String dim;
        if (environment.compareTo(World.Environment.NORMAL) == 0) {
            dim = "O";
        }
        else if (environment.compareTo(World.Environment.NETHER) == 0) {
            dim = "N";
        }
        else if (environment.compareTo(World.Environment.THE_END) == 0) {
            dim = "E";
        }
        else {
            dim = null;
        }

        return dim;
    }
}
